
/**
 * InputSearch
 * @author tianyanrong
 */
import React, { Component } from 'react';
import { DatePicker } from 'antd';
const { RangePicker} = DatePicker;
import moment from 'moment';

class InputSearch extends Component {
  onChange = (dates, dateStrings) => {
    const {startCallback, endCallback} = this.props;
    console.log(777, this.props)
    if(startCallback && typeof startCallback === 'function') {
      startCallback(dateStrings[0]);
    }
    if(endCallback && typeof endCallback === 'function') {
      endCallback(dateStrings[1]);
    }
  }
  render() {
    const {
      startPlaceholder = '',
      endPlaceholder = '',
      autoFocus,
      size,
      disabled,
      mode,
      format,
      minDate,
      maxDate,
      minMonth,
      maxMonth
    } = this.props;
    let newFormat = format;
    if(mode === 'month') {
      newFormat = 'YYYY-MM';
    }
    else if(mode === 'date') {
      newFormat = 'YYYY-MM-DD';
    }
    else {
      newFormat = 'YYYY-MM-DD HH:mm:ss';
    }
    let placeholder = null;
    if(startPlaceholder || endPlaceholder) {
      placeholder = [startPlaceholder, endPlaceholder];
    }
    return mode === 'month' ? <RangePicker
      placeholder={placeholder}
      autoFocus={autoFocus ? true : false}
      size={size ? size : null}
      disabled={disabled ? true : false}
      mode={['month', 'month']}
      format={newFormat}
      disabledDate={(current) => {
        return (minMonth && current <= moment().add(Number(`-${minMonth}`) + 1, 'month')) || (maxMonth && current > moment().add(Number(`${maxMonth}`), 'month'));
      }}
      onChange={(dates, dateStrings) => {
        this.onChange(dates, dateStrings);
      }}
      className={this.props.className}
      style={this.props.style}
    /> : <RangePicker
      placeholder={placeholder}
      autoFocus={autoFocus ? true : false}
      size={size ? size : null}
      disabled={disabled ? true : false}
      {...(mode === 'dateTime' ? {showTime: true} : {})}
      format={newFormat}
      disabledDate={(current) => {
        return (minDate && current <= moment().add(Number(`-${minDate}`) + 1, 'day')) || (maxDate && current > moment().add(Number(`${maxDate}`), 'day'));
      }}
      onChange={(dates, dateStrings) => {
        this.onChange(dates, dateStrings);
      }}
      className={this.props.className}
      style={Object.assign({width: 'auto'}, this.props.style)}
    />;
  }
}
export default InputSearch;


